<?php

class Login extends CI_Controller {

    function __construct() {
        parent::__construct();
        $this->load->library('session');
        //$this->load->helper('form', 'url');
        $this->load->library('form_validation');
        $this->load->helper(array('form', 'url'));
        $this->load->model('login_model');
    }

    function index() {
        if ($this->session->userdata('user_name') != '') {
            $this->home();
        } else {
            if ($this->is_installed()) {                
                $current_version = $this->config->item('current_version');
                $db_current_version = $this->login_model->get_current_version();		
                if ($current_version == $db_current_version) {
                    $this->load->view('templates/header');
                    $this->load->view('login/login_signup');
                    $this->load->view('templates/footer');
                } else {
                    redirect(base_url().'install.php', 'refresh');
                }
            } else {
                redirect(base_url().'install.php', 'refresh');
            }
        }
    }

    function home() {
        if ($this->session->userdata('user_name') == '') {
            $this->index();
        } else {
            redirect('/appointment/index', 'refresh');
        }
    }

    function valid_signin() {
        $this->form_validation->set_rules('username', 'Username', 'trim|required|min_length[5]|max_length[12]|xss_clean');
        $this->form_validation->set_rules('password', 'Password', 'trim|required');
        if ($this->form_validation->run() == FALSE) {
            $this->index();
        } else {
            $this->login();
        }
    }

    function login() {
        $username = $this->input->post('username');
        $password = base64_encode($this->input->post('password'));
        $result = $this->login_model->login($username, $password);
        if ($result) {
            $this->home();
        } else {
            $data['username'] = $this->input->post('username');
            $data['level'] = $this->input->post('level');
            $this->load->view('templates/header');
            $this->load->view('signin_fail', $data);
            $this->load->view('templates/footer');
        }
    }

    public function logout() {
        $newdata = array('name' => '', 'user_name' => '', 'category' => '', 'logged_in' => FALSE,);
        $this->session->unset_userdata($newdata);
        $this->session->sess_destroy();
        $this->index();
    }

    public function is_installed() {
        $config_file = "application/config/config.php";
        $line_array = file($config_file);

        for ($i = 0; $i < count($line_array); $i++) {
            if (strstr($line_array[$i], "['install']")) {
                if (strstr($line_array[$i], '$config[\'install\'] = 0;')) {
                    // Application is not installed
                    return FALSE;
                } elseif (strstr($line_array[$i], '$config[\'install\'] = 1;')) {
                    // Application is installed
                    return TRUE;
                }
            }
        }
    }

}

?>
