<?php

class Template extends CI_Controller {

    function __construct() {
        parent::__construct();
        $this->load->model('template_model');
        $this->load->helper('form');
        $this->load->library('form_validation');
    }

    public function index($note = NULL) {
        if ($this->session->userdata('user_name') == '') {
            redirect('login/index');
        } else {
            $data['templates'] = $this->template_model->get();
            $data['note'] = $note;
            $this->load->view('templates/header');
            $this->load->view('templates/menu');
            $this->load->view('index', $data);
            $this->load->view('templates/footer');
        }
    }

    public function form($template_name = NULL) {
        if ($this->session->userdata('user_name') == '') {
            redirect('login/index');
        } else {
            $this->form_validation->set_rules('template_name', 'Template Name', 'required');
            $this->form_validation->set_rules('template_content', 'Template Content', 'required');
            if ($this->form_validation->run() === FALSE) {
                $data['template_name'] = $template_name;
                if (!$_POST and $template_name) {
                    $data['content'] = $this->template_model->get_content($template_name);
                } else {
                    $data['content'] = '';
                }
                $data['dir_is_writable'] = $this->template_model->dir_is_writable();
                $data['template_dir'] = $this->template_model->get_dir_path();

                $this->load->view('templates/header');
                $this->load->view('templates/menu');
                $this->load->view('form', $data);
                $this->load->view('templates/footer');
            } else {
                $note = $this->template_model->save();

                $this->index($note);
            }
        }
    }

    public function delete($template_name) {
        if ($this->session->userdata('user_name') == '') {
            redirect('login/index');
        } else {
            $note = $this->template_model->delete($template_name);
            $this->index($note);
        }
    }
}

?>
