<?php

class Template_model extends CI_Model {

    public function __construct() {
        $this->load->helper('directory');
    }

    public function get() {

        /* Get the initial map of files in the template directory. */
        $map = directory_map(APPPATH . '/modules_core/patient/views/receipt_template/', TRUE);

        foreach ($map as $key => $value) {

            if (substr($value, -4) <> '.php') {

                /* Remove this file from the array if it doesn't have a .php extension. */
                unset($map[$key]);
            } else {

                /* Yep - it's got a .php extension, so let's keep it. */
                $map[$key] = substr($map[$key], 0, -4);
            }
        }

        //sort($map);

        /* Return the list of files to the controller. */
        return $map;
    }

    public function get_content($template_name) {
        return read_file(APPPATH . 'modules_core/patient/views/receipt_template/' . $template_name . '.php');
    }

    public function get_dir_path() {
        return APPPATH . 'modules_core/patient/views/receipt_template/';
    }

    public function dir_is_writable() {

        if (is_writable(APPPATH . '/modules_core/patient/views/receipt_template/')) {

            return TRUE;
        }

        return FALSE;
    }

    public function save() {

        $template_filename = $this->input->post('template_name');

        $template_content = $this->input->post('template_content');

        $this->load->helper('file');

        if (write_file(APPPATH . '/modules_core/patient/views/receipt_template/' . $template_filename . '.php', $template_content)) {

            return 'Success Save';
        }
    }

    function delete($template_name) {
        if (count($this->get()) > 1) {
            if (unlink(APPPATH . 'modules_core/patient/views/receipt_template/' . $template_name . '.php')) {
                return 'Success delete';
                //$this->session->set_flashdata('success_delete', TRUE);
            }
        } else {
            return 'Template cannot be deleted';
            //$this->session->set_flashdata('custom_error', $this->lang->line('template_cannot_be_deleted'));
        }
    }

}

?>
